### Method

# Gck Session generate_key_pair

#### Declaration [src]

    gboolean
    gck_session_generate_key_pair (
      GckSession* self,
      gulong mech_type,
      GckAttributes* public_attrs,
      GckAttributes* private_attrs,
      GckObject** public_key,
      GckObject** private_key,
      GCancellable* cancellable,
      GError** error
    )

#### Description [src]

Generate a new key pair of public and private keys. This call may block for an indefinite period.

If `public_attrs` and/or `private_attrs` is a floating reference, it is consumed.

#### Parameters

`mech_type`

  Type: `gulong`

  The mechanism type to use for key generation.

`public_attrs`

  Type: `GckAttributes`

  Additional attributes for the generated public key.

  The data is owned by the caller of the method.

`private_attrs`

  Type: `GckAttributes`

  Additional attributes for the generated private key.

  The data is owned by the caller of the method.

`public_key`

  Type: `GckObject`

  Location to return the resulting public key.

  The argument will be set by the function.
  The argument can be `NULL`.
  The caller of the method takes ownership of the returned data, and is responsible for freeing it.

`private_key`

  Type: `GckObject`

  Location to return the resulting private key.

  The argument will be set by the function.
  The argument can be `NULL`.
  The caller of the method takes ownership of the returned data, and is responsible for freeing it.

`cancellable`

  Type: `GCancellable`

  Optional cancellation object, or `NULL`.

  The argument can be `NULL`.
  The data is owned by the caller of the method.

`error`

  Type: `GError **`

  The return location for a recoverable error.

  The argument can be `NULL`.
  If the return location is not `NULL`, then you must initialize it to a `NULL` `GError*`.
  The argument will be left initialized to `NULL` by the method if there are no errors.
  In case of error, the argument will be set to a newly allocated `GError`; the caller will take ownership of the data, and be responsible for freeing it.

#### Return value

Type: `gboolean`

`TRUE` if the operation succeeded.